#ifndef __COMMON_GEOMETRY_H__
#define __COMMON_GEOMETRY_H__

/* Type: vector3d_t
 * contient un tableau representant les 3 coordonnees x, y et z
 * cette representation est plus simple pour utiliser avec OpenGL
 * compare  celle  3 champs x, y et z distincts
 */
typedef struct vector3d_t {
  float coord[3]; /* x, y, z */
  
} vector3d_t;

/* Type: triangle3d_t
 *
 */
typedef struct triangle3d_t {
  vector3d_t vertices[3];
  vector3d_t normal;
  
} triangle3d_t;

/* voir common_geometry.c pour les descriptions de ces fonctions */
void set_vector(vector3d_t *vector, float x, float y, float z);
vector3d_t cross_product_vect(vector3d_t v1, vector3d_t v2);
vector3d_t cross_product(vector3d_t v1, vector3d_t v2, vector3d_t v3);
float get_vect_length(vector3d_t v);
void normalize(vector3d_t *v);
vector3d_t cross_product(vector3d_t v1, vector3d_t v2, vector3d_t v3);
void set_triangle(triangle3d_t *triangle, vector3d_t v1, vector3d_t v2,
      vector3d_t v3);

#endif
