#include "../projet.h"

#ifdef USE_GLUT
param_hyperb_t hyp_param;

void
glut_reshape(int w, int h)
{
  gl_generic_resize (w, h);
}

void
glut_display(void)
{
  gl_generic_render_scene();
   
  glutSwapBuffers(); 
}

void glut_idle(void)
{
  glutPostRedisplay();
}

void fill_default_hyperb_params (param_hyperb_t *params)
{
  params->num_iter = 50;
  params->radius_min = 10;
  params->radius_max = 30;
  params->power = 0.3333;
  params->factor = 50;
  params->epsilon_type = 0;
}

void set_up_glut()
{   
  glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(800,600);
  glutCreateWindow("Terrain preview");
  gl_generic_init();
  
  /* parametres du terrain */
  terrain->size = 129;
  terrain->algo = TERR_HYPERB;
  fill_default_hyperb_params (&hyp_param);
  terrain->spec_param = (void *) &hyp_param;
  
  ui_generic_generate_new_terrain (terrain);

  glutDisplayFunc(glut_display);
  glutReshapeFunc(glut_reshape);
  glutIdleFunc(glut_idle);
}

#endif /* USE_GLUT */
