#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#include "terrain.h"
#include "common.h"

void
gen_terrain_hyperbole (terrain_t * terrain)
{
  int x1, y1, x2, y2;
  float z = 0;
  float radius = 1.0f;
  int iter = 0;
  float dist = 0.0f;
  float r1 = 0.0f;
  int epsilon = 0;
  param_hyperb_t *param;

  srand (time (NULL));

  param = (param_hyperb_t *) terrain->spec_param;
  if (!param) {
    fprintf(stderr, "Error: no parameters found\n");
    return;
  }

  for (iter = 0; iter < param->num_iter; iter++) {

    x1 = random_int (terrain->size - 1);
    y1 = random_int (terrain->size - 1);
    /*radius = random_float(10.0f,30.0f); */
    radius = random_float (param->radius_min, param->radius_max);
    r1 = radius * 0.333f;

    /*epsilon = random_int(3) - 1; */
    epsilon = random_int (2);
    /*epsilon = 0; */

    for (x2 = 0; x2 < terrain->size; x2++) {
      for (y2 = 0; y2 < terrain->size; y2++) {

	dist = sqrt ((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));

	if ((dist < radius) && (dist > r1) && (dist > 0))
	  z =
	    param->factor /
	    (float) (pow ((double) (dist), param->power))
	    -
	    param->factor /
	    (float) (pow ((double) (radius), param->power));
	else if (dist <= r1)
	  z =
	    param->factor /
	    (float) (pow ((double) (r1), param->power))
	    -
	    param->factor /
	    (float) (pow ((double) (radius), param->power))

	  + (float) epsilon *sqrt (r1 * r1 -
				   ((x2 - x1) * (x2 - x1) +
				    (y2 - y1) * (y2 - y1)));

	else
	z = 0;

	z += get_heightmap_value (terrain, x2, y2);

	if (z > terrain->max_height)
	  terrain->max_height = z;

	set_heightmap_value (terrain, x2, y2, z);
      }
    }
  }

  printf ("HYPERB: max_height=%f\n", terrain->max_height);

}
